From f308e0673951987a7c68baac16c6b089bc516ed1 Mon Sep 17 00:00:00 2001
From: Chenxiong Qi <cqi@redhat.com>
Date: Jan 03 2018 05:41:10 +0000
Subject: [PATCH 2/7] Add many-2-many relationship between ArtifactBuild and Compose


This is used to refactor storing ODCS compose IDs for artifact builds
that will be rebuilt.

For a particular event to rebuild series of images, this new database
schema change will be able to describe like this, an event will rebuild
several images, and each build has ODCS composes containing
updated RPMs.

We can get all composes IDs through this many-2-many
relationship instead of gathering them from Event.compose_id and
ArtifactBuild.build_args. Meanwhile, it will be easy and flexible for
adding more composes IDs to a build without changing schema.

Signed-off-by: Chenxiong Qi <cqi@redhat.com>

---

diff --git a/freshmaker/models.py b/freshmaker/models.py
index 72830c4..f830647 100644
--- a/freshmaker/models.py
+++ b/freshmaker/models.py
@@ -382,6 +382,8 @@ class ArtifactBuild(FreshmakerBase):
     # Build args in json format.
     build_args = db.Column(db.String, nullable=True)
 
+    composes = db.relationship('ArtifactBuildCompose', back_populates='build')
+
     @classmethod
     def create(cls, session, event, name, type,
                build_id=None, dep_on=None, state=None,
@@ -506,3 +508,29 @@ class ArtifactBuild(FreshmakerBase):
             else:
                 break
         return dep_on
+
+
+class Compose(FreshmakerBase):
+    __tablename__ = 'composes'
+
+    id = db.Column(db.Integer, primary_key=True)
+    odcs_compose_id = db.Column(db.Integer, nullable=False)
+
+    builds = db.relationship('ArtifactBuildCompose', back_populates='compose')
+
+
+class ArtifactBuildCompose(FreshmakerBase):
+    __tablename__ = 'artifact_build_composes'
+
+    build_id = db.Column(
+        db.Integer,
+        db.ForeignKey('artifact_builds.id'),
+        primary_key=True)
+
+    compose_id = db.Column(
+        db.Integer,
+        db.ForeignKey('composes.id'),
+        primary_key=True)
+
+    build = db.relationship('ArtifactBuild', back_populates='composes')
+    compose = db.relationship('Compose', back_populates='builds')
diff --git a/tests/test_models.py b/tests/test_models.py
index 5ad49d9..241cc9d 100644
--- a/tests/test_models.py
+++ b/tests/test_models.py
@@ -25,6 +25,7 @@ import unittest
 from freshmaker import db, events
 from freshmaker.models import ArtifactBuild, ArtifactType
 from freshmaker.models import Event, EventState, EVENT_TYPES, EventDependency
+from freshmaker.models import Compose, ArtifactBuildCompose
 from freshmaker.types import ArtifactBuildState
 from freshmaker.events import ErrataAdvisoryRPMsSignedEvent
 
@@ -277,3 +278,83 @@ class TestFindDependentEvents(unittest.TestCase):
         self.assertEqual(2, len(dep_rels))
         self.assertIn((self.event_1.id, self.event_2.id), dep_rels)
         self.assertIn((self.event_1.id, self.event_3.id), dep_rels)
+
+
+class TestArtifactBuildComposesRel(unittest.TestCase):
+    """Test m2m relationship between ArtifactBuild and Compose"""
+
+    def setUp(self):
+        db.session.remove()
+        db.drop_all()
+        db.create_all()
+        db.session.commit()
+
+        self.compose_1 = Compose(odcs_compose_id=1)
+        self.compose_2 = Compose(odcs_compose_id=2)
+        self.compose_3 = Compose(odcs_compose_id=3)
+        self.compose_4 = Compose(odcs_compose_id=4)
+        db.session.add(self.compose_1)
+        db.session.add(self.compose_2)
+        db.session.add(self.compose_3)
+        db.session.add(self.compose_4)
+
+        self.event = Event.create(
+            db.session, 'msg-1', 'search-key-1',
+            EVENT_TYPES[ErrataAdvisoryRPMsSignedEvent],
+            state=EventState.INITIALIZED,
+            released=False)
+        self.build_1 = ArtifactBuild.create(
+            db.session, self.event, 'build-1', ArtifactType.IMAGE)
+        self.build_2 = ArtifactBuild.create(
+            db.session, self.event, 'build-2', ArtifactType.IMAGE)
+        self.build_3 = ArtifactBuild.create(
+            db.session, self.event, 'build-3', ArtifactType.IMAGE)
+
+        db.session.commit()
+
+        rels = (
+            (self.build_1.id, self.compose_1.id),
+            (self.build_1.id, self.compose_2.id),
+            (self.build_1.id, self.compose_3.id),
+            (self.build_2.id, self.compose_2.id),
+            (self.build_2.id, self.compose_4.id),
+        )
+
+        for build_id, compose_id in rels:
+            db.session.add(
+                ArtifactBuildCompose(
+                    build_id=build_id, compose_id=compose_id))
+
+        db.session.commit()
+
+    def tearDown(self):
+        db.session.remove()
+        db.drop_all()
+        db.session.commit()
+
+    def test_build_composes(self):
+        self.assertEqual(3, len(self.build_1.composes))
+        self.assertEqual(
+            [self.compose_1.id, self.compose_2.id, self.compose_3.id],
+            sorted([rel.compose.id for rel in self.build_1.composes]))
+
+        self.assertEqual(2, len(self.build_2.composes))
+        self.assertEqual(
+            [self.compose_2.id, self.compose_4.id],
+            sorted([rel.compose.id for rel in self.build_2.composes]))
+
+        self.assertEqual([], self.build_3.composes)
+
+    def test_compose_builds(self):
+        expected_rels = (
+            (self.compose_1, 1, [self.build_1.id]),
+            (self.compose_2, 2, [self.build_1.id, self.build_2.id]),
+            (self.compose_3, 1, [self.build_1.id]),
+            (self.compose_4, 1, [self.build_2.id]),
+        )
+
+        for compose, builds_count, builds in expected_rels:
+            self.assertEqual(builds_count, len(compose.builds))
+            self.assertEqual(
+                builds,
+                sorted([rel.build.id for rel in compose.builds]))

